#pragma semicolon 1

#include <sourcemod>
#include <sdktools_sound>
#include <sdktools_stringtables>

public Plugin:myinfo = 
{
	name	= "Round Start Music",
	author	= "wS (World-Source.Ru)",
	version	= "1.2"
};

new Handle:g_Array;
new g_Sounds_Count;
new g_CurrPos = -1;
new bool:g_CanListen[MAXPLAYERS + 1] = {true, ...};

public OnPluginStart()
{
	new Handle:dir = OpenDirectory("sound/round_start_music");
	if (dir == INVALID_HANDLE)
		SetFailState("Не удалось открыть \"sound/round_start_music\"");

	g_Array = CreateArray(150);
	decl String:SoundName[150], FileType:type;
	while (ReadDirEntry(dir, SoundName, 150, type))
	{
		if (type == FileType_File && StrContains(SoundName, ".ztmp") == -1)
		{
			if (StrContains(SoundName, ".mp3") > 0 || StrContains(SoundName, ".wav") > 0)
			{
				Format(SoundName, 150, "round_start_music/%s", SoundName);
				PushArrayString(g_Array, SoundName);
			}
		}
	}
	CloseHandle(dir);

	if ((g_Sounds_Count = GetArraySize(g_Array)) < 1)
		SetFailState("В \"sound/round_start_music\" нет звуков");

	HookEvent("round_freeze_end", round_freeze_end, EventHookMode_PostNoCopy);
	RegConsoleCmd("sm_rsm", sm_rsm_cmd);
	RegConsoleCmd("sm_stopmusic", sm_stopmusic_cmd);
}

public OnMapStart()
{
	decl String:SoundName[150];
	for (new i = 0; i < g_Sounds_Count; i++)
	{
		GetArrayString(g_Array, i, SoundName, 150); PrecacheSound(SoundName, true);
		Format(SoundName, 150, "sound/%s", SoundName); AddFileToDownloadsTable(SoundName);
	}
}

public round_freeze_end(Handle:event, const String:name[], bool:silent)
{
	if (++g_CurrPos >= g_Sounds_Count) g_CurrPos = 0;
	decl String:SoundName[150]; GetArrayString(g_Array, g_CurrPos, SoundName, 150);
	for (new i = 1; i <= MaxClients; i++)
	{
		if (g_CanListen[i] && IsClientInGame(i) && !IsFakeClient(i))
		{
			EmitSoundToClient(i, SoundName);
		}
	}
}

public Action:sm_stopmusic_cmd(client, args)
{
	if( IsClientInGame( client ) && !IsFakeClient( client ) )
	{
		decl String:SoundName[150];
		GetArrayString(g_Array, client, SoundName, 150);
		StopSound( client, SNDCHAN_STATIC, SoundName );
	}
}


public Action:sm_rsm_cmd(client, args)
{
	if (0 < client <= MaxClients)
		PrintToChat(client, (g_CanListen[client] = !g_CanListen[client]) ? "\x04Музыка в начале раунда включена" : "Музыка в начале раунда отключена");

	return Plugin_Handled;
}

public OnClientPutInServer(client)
{
	g_CanListen[client] = true;
}